/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "Trigger.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerMask_Initialize(TriggerMask* pVal)
{
    *pVal = (TriggerMask) {    .arr =
    {
        FALSE
    }
};
}
#endif


flag TriggerMask_IsConstraintValid(const TriggerMask* pVal, int* pErrCode)
{

    flag ret = TRUE;
	int i1=0;
	*pErrCode=0;

	(void)pVal;

	ret = TRUE; *pErrCode = 0;
	i1 = 0;
	while (ret && (i1< 8)) {
	    ret = T_Boolean_IsConstraintValid(&pVal->arr[i1], pErrCode);
	    i1 = i1+1;
	}

	return ret;
}

flag TriggerMask_Encode(const TriggerMask* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1=0;

	ret = bCheckConstraints ? TriggerMask_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {

	    for(i1=0; (i1 < (int)8) && ret; i1++)
	    {
	    	ret = T_Boolean_Encode(&pVal->arr[i1], pBitStrm, pErrCode, FALSE);
	    }
    }

	return ret;
}

flag TriggerMask_Decode(TriggerMask* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1=0;


	for(i1=0; (i1 < (int)8) && ret; i1++)
	{
		ret = T_Boolean_Decode(&pVal->arr[i1], pBitStrm, pErrCode);
	}

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerGenerator_Initialize(TriggerGenerator* pVal)
{
    *pVal = (TriggerGenerator) 1;
}
#endif


flag TriggerGenerator_IsConstraintValid(const TriggerGenerator* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (1 <= *pVal && *pVal <= 4);
	*pErrCode = ret ? 0 : ERR_TriggerGenerator;

	return ret;
}

flag TriggerGenerator_Encode(const TriggerGenerator* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? TriggerGenerator_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 1, 4);
    }

	return ret;
}

flag TriggerGenerator_Decode(TriggerGenerator* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 1, 4);
	*pErrCode = ret ? 0 : 273678337;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerInput_Initialize(TriggerInput* pVal)
{
    *pVal = (TriggerInput) 1;
}
#endif


flag TriggerInput_IsConstraintValid(const TriggerInput* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (1 <= *pVal && *pVal <= 4);
	*pErrCode = ret ? 0 : ERR_TriggerInput;

	return ret;
}

flag TriggerInput_Encode(const TriggerInput* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? TriggerInput_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 1, 4);
    }

	return ret;
}

flag TriggerInput_Decode(TriggerInput* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 1, 4);
	*pErrCode = ret ? 0 : 273678338;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerOutput_Initialize(TriggerOutput* pVal)
{
    *pVal = (TriggerOutput) 1;
}
#endif


flag TriggerOutput_IsConstraintValid(const TriggerOutput* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (1 <= *pVal && *pVal <= 8);
	*pErrCode = ret ? 0 : ERR_TriggerOutput;

	return ret;
}

flag TriggerOutput_Encode(const TriggerOutput* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? TriggerOutput_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 1, 8);
    }

	return ret;
}

flag TriggerOutput_Decode(TriggerOutput* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 1, 8);
	*pErrCode = ret ? 0 : 273678339;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerPeriod_Initialize(TriggerPeriod* pVal)
{
    *pVal = (TriggerPeriod) 0;
}
#endif


flag TriggerPeriod_IsConstraintValid(const TriggerPeriod* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (*pVal <= 16777215);
	*pErrCode = ret ? 0 : ERR_TriggerPeriod;

	return ret;
}

flag TriggerPeriod_Encode(const TriggerPeriod* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? TriggerPeriod_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 0, 16777215);
    }

	return ret;
}

flag TriggerPeriod_Decode(TriggerPeriod* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 0, 16777215);
	*pErrCode = ret ? 0 : 273678340;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void GeneratorSetup_Initialize(GeneratorSetup* pVal)
{
    *pVal = (GeneratorSetup) {
    .generator = 1,
    .period = 0
};
}
#endif


flag GeneratorSetup_IsConstraintValid(const GeneratorSetup* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = TriggerGenerator_IsConstraintValid(&pVal->generator, pErrCode);
	if (ret) {
	    ret = TriggerPeriod_IsConstraintValid(&pVal->period, pErrCode);

	}

	return ret;
}

flag GeneratorSetup_Encode(const GeneratorSetup* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? GeneratorSetup_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode generator */
	    ret = TriggerGenerator_Encode(&pVal->generator, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode period */
	        ret = TriggerPeriod_Encode(&pVal->period, pBitStrm, pErrCode, FALSE);

	    }
    }

	return ret;
}

flag GeneratorSetup_Decode(GeneratorSetup* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode generator */
	ret = TriggerGenerator_Decode(&pVal->generator, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode period */
	    ret = TriggerPeriod_Decode(&pVal->period, pBitStrm, pErrCode);

	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerOffset_Initialize(TriggerOffset* pVal)
{
    *pVal = (TriggerOffset) 0;
}
#endif


flag TriggerOffset_IsConstraintValid(const TriggerOffset* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (*pVal <= 16777215);
	*pErrCode = ret ? 0 : ERR_TriggerOffset;

	return ret;
}

flag TriggerOffset_Encode(const TriggerOffset* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? TriggerOffset_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 0, 16777215);
    }

	return ret;
}

flag TriggerOffset_Decode(TriggerOffset* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 0, 16777215);
	*pErrCode = ret ? 0 : 273678341;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void TriggerDuration_Initialize(TriggerDuration* pVal)
{
    *pVal = (TriggerDuration) 0;
}
#endif


flag TriggerDuration_IsConstraintValid(const TriggerDuration* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (*pVal <= 1023);
	*pErrCode = ret ? 0 : ERR_TriggerDuration;

	return ret;
}

flag TriggerDuration_Encode(const TriggerDuration* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? TriggerDuration_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 0, 1023);
    }

	return ret;
}

flag TriggerDuration_Decode(TriggerDuration* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 0, 1023);
	*pErrCode = ret ? 0 : 273678342;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ChannelInternal_Initialize(ChannelInternal* pVal)
{
    *pVal = (ChannelInternal) {
    .channel = 1,
    .source = 1,
    .offset = 0,
    .duration = 0,
    .invert = FALSE
};
}
#endif


flag ChannelInternal_IsConstraintValid(const ChannelInternal* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = TriggerOutput_IsConstraintValid(&pVal->channel, pErrCode);
	if (ret) {
	    ret = TriggerGenerator_IsConstraintValid(&pVal->source, pErrCode);
	    if (ret) {
	        ret = TriggerOffset_IsConstraintValid(&pVal->offset, pErrCode);
	        if (ret) {
	            ret = TriggerDuration_IsConstraintValid(&pVal->duration, pErrCode);
	            if (ret) {
	                ret = T_Boolean_IsConstraintValid(&pVal->invert, pErrCode);

	            }
	        }
	    }
	}

	return ret;
}

flag ChannelInternal_Encode(const ChannelInternal* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? ChannelInternal_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode channel */
	    ret = TriggerOutput_Encode(&pVal->channel, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode source */
	        ret = TriggerGenerator_Encode(&pVal->source, pBitStrm, pErrCode, FALSE);
	        if (ret) {
	            /*Encode offset */
	            ret = TriggerOffset_Encode(&pVal->offset, pBitStrm, pErrCode, FALSE);
	            if (ret) {
	                /*Encode duration */
	                ret = TriggerDuration_Encode(&pVal->duration, pBitStrm, pErrCode, FALSE);
	                if (ret) {
	                    /*Encode invert */
	                    ret = T_Boolean_Encode(&pVal->invert, pBitStrm, pErrCode, FALSE);

	                }
	            }
	        }
	    }
    }

	return ret;
}

flag ChannelInternal_Decode(ChannelInternal* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode channel */
	ret = TriggerOutput_Decode(&pVal->channel, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode source */
	    ret = TriggerGenerator_Decode(&pVal->source, pBitStrm, pErrCode);
	    if (ret) {
	        /*Decode offset */
	        ret = TriggerOffset_Decode(&pVal->offset, pBitStrm, pErrCode);
	        if (ret) {
	            /*Decode duration */
	            ret = TriggerDuration_Decode(&pVal->duration, pBitStrm, pErrCode);
	            if (ret) {
	                /*Decode invert */
	                ret = T_Boolean_Decode(&pVal->invert, pBitStrm, pErrCode);

	            }
	        }
	    }
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ChannelExternal_Initialize(ChannelExternal* pVal)
{
    *pVal = (ChannelExternal) {
    .channel = 1,
    .source = 1,
    .offset = 0,
    .duration = 0,
    .bypass = FALSE,
    .invert = FALSE
};
}
#endif


flag ChannelExternal_IsConstraintValid(const ChannelExternal* pVal, int* pErrCode)
{

    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = TriggerOutput_IsConstraintValid(&pVal->channel, pErrCode);
	if (ret) {
	    ret = TriggerInput_IsConstraintValid(&pVal->source, pErrCode);
	    if (ret) {
	        ret = TriggerOffset_IsConstraintValid(&pVal->offset, pErrCode);
	        if (ret) {
	            ret = TriggerDuration_IsConstraintValid(&pVal->duration, pErrCode);
	            if (ret) {
	                ret = T_Boolean_IsConstraintValid(&pVal->bypass, pErrCode);
	                if (ret) {
	                    ret = T_Boolean_IsConstraintValid(&pVal->invert, pErrCode);

	                }
	            }
	        }
	    }
	}

	return ret;
}

flag ChannelExternal_Encode(const ChannelExternal* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;

	ret = bCheckConstraints ? ChannelExternal_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode channel */
	    ret = TriggerOutput_Encode(&pVal->channel, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode source */
	        ret = TriggerInput_Encode(&pVal->source, pBitStrm, pErrCode, FALSE);
	        if (ret) {
	            /*Encode offset */
	            ret = TriggerOffset_Encode(&pVal->offset, pBitStrm, pErrCode, FALSE);
	            if (ret) {
	                /*Encode duration */
	                ret = TriggerDuration_Encode(&pVal->duration, pBitStrm, pErrCode, FALSE);
	                if (ret) {
	                    /*Encode bypass */
	                    ret = T_Boolean_Encode(&pVal->bypass, pBitStrm, pErrCode, FALSE);
	                    if (ret) {
	                        /*Encode invert */
	                        ret = T_Boolean_Encode(&pVal->invert, pBitStrm, pErrCode, FALSE);

	                    }
	                }
	            }
	        }
	    }
    }

	return ret;
}

flag ChannelExternal_Decode(ChannelExternal* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode channel */
	ret = TriggerOutput_Decode(&pVal->channel, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode source */
	    ret = TriggerInput_Decode(&pVal->source, pBitStrm, pErrCode);
	    if (ret) {
	        /*Decode offset */
	        ret = TriggerOffset_Decode(&pVal->offset, pBitStrm, pErrCode);
	        if (ret) {
	            /*Decode duration */
	            ret = TriggerDuration_Decode(&pVal->duration, pBitStrm, pErrCode);
	            if (ret) {
	                /*Decode bypass */
	                ret = T_Boolean_Decode(&pVal->bypass, pBitStrm, pErrCode);
	                if (ret) {
	                    /*Decode invert */
	                    ret = T_Boolean_Decode(&pVal->invert, pBitStrm, pErrCode);

	                }
	            }
	        }
	    }
	}


	return ret;
}
